VERSION 5.00
Begin VB.UserControl stClock 
   ClientHeight    =   2490
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2595
   Enabled         =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   166
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   173
   ToolboxBitmap   =   "stClock.ctx":0000
End
Attribute VB_Name = "stClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'Lists
Enum ViewClockList
   Normal
   Sunken
End Enum
Enum ViewHandList
   Needle
   Rhomb
   Rhomb3D
End Enum
'Default Property Values:
Const m_def_ShowTime = True
Const m_def_ClockTime = "00:00:00"
Const m_def_SecondHand = True
Const m_def_ViewClock = 0
Const m_def_ViewHand = 0
Const m_def_HourLabels = True
Const m_def_MinuteLabels = False
'Property Variables:
Dim m_ShowTime As Boolean
Dim m_ClockTime As String * 8
Dim m_SecondHand As Boolean
Dim m_ViewClock As ViewClockList
Dim m_ViewHand As ViewHandList
Dim m_HourLabels As Boolean
Dim m_MinuteLabels As Boolean
'my variables
Dim PI As Single, Deg As Single
Dim sHour As Single, sMinu As Single, sSeco As Single
Dim MaxR As Single 'radii
Dim HourHand As Single
Dim MinuHand As Single
Dim Xc As Single
Dim Yc As Single
'Event Declarations:
Event Change()
Attribute Change.VB_Description = "Whenever the ClockTime changes."

' clocktime changed by string
Private Sub NewClockTimeStr()
   sHour = Val(Left(m_ClockTime, 2))
   sMinu = Val(Mid(m_ClockTime, 4, 2))
   sSeco = Val(Right(m_ClockTime, 2))
   sHour = sHour + sMinu / 60
   RaiseEvent Change
End Sub

' clocktime changed by mouse
Private Sub NewClockTimeXY(ByVal x As Single, ByVal y As Single)
   Static pMinu, pHour ' p=previous
   
   Dim Radii As Single, Angle As Single
   
   ' determine the angle and distance from center
   Radii = Sqr(Abs(x - Xc) ^ 2 + Abs(y - Yc) ^ 2)
   If Yc <> y Then
      Angle = (Atn((x - Xc) / (y - Yc)) + 1.5708) * 180 / PI
      If Sgn(y - Yc) = 1 Then Angle = 180 + Angle
      Else
      If Xc > x Then Angle = 180 Else Angle = 0
      End If
   
   Angle = (450 - Angle) Mod 360
   
   If Radii < Xc * HourHand Then
      ' mouse in hour-hand zone
      sHour = Angle / 30
      sMinu = Int(((Angle / 30) - Int(Angle / 30)) * 60)
      If Int(sHour) <> Int(pHour) Then
         If (Int(pHour) = 23 Or Int(pHour) = 11) And Int(sHour) = 0 Then
            If Int(pHour) = 23 Then sHour = sHour - 12
            If Int(pHour) = 11 Then sHour = sHour + 12
         ElseIf (Int(pHour) = 12 Or Int(pHour) = 0) And Int(sHour) = 11 Then
            If Int(pHour) = 12 Then sHour = sHour - 12
            If Int(pHour) = 0 Then sHour = sHour + 12
         Else
         If pHour >= 12 Then sHour = sHour + 12
         End If
      End If
      If sHour < 0 Then sHour = sHour + 12
      
      Else
      
      ' mouse in minute-hand zone
      sMinu = Angle \ 6
      sHour = Int(sHour) + sMinu / 60
      If pMinu > 55 And sMinu < 5 Then
         sHour = sHour + 1
         If sHour >= 24 Then sHour = sHour - 24
         End If
      If pMinu < 5 And sMinu > 55 Then
         sHour = sHour - 1
         If sHour <= 0 Then sHour = sHour + 24
         End If
      End If
         
   pMinu = sMinu
   pHour = sHour
   sSeco = 0
   RaiseEvent Change
End Sub

' redraw the clock
Private Sub DrawClock()
   Dim R As Single 'Radii
   Dim F As Single 'Factor
   
   FontSize = 7
   AutoRedraw = True
   F = 1

   ' clear screen
   Line (0, 0)-(ScaleWidth, ScaleHeight), BackColor, BF

   ' MinuteLabels
   If m_MinuteLabels = True Then
      F = F - 0.1: R = MaxR * F
      If m_ViewClock = 1 Then DrawMinuLabels QBColor(15), R, 1, 1
      DrawMinuLabels QBColor(0), R, 0, 0
      End If

   ' minute "calibration"
   F = F - 0.1: R = MaxR * F
   DrawCircPts 1, QBColor(15), 6, R, 0, 0
   If m_ViewClock = 1 Then DrawCircPts 2, QBColor(15), 30, R, 1, 1
   DrawCircPts 2, QBColor(0), 30, R, 0, 0
   MinuHand = F
   
   ' HourLabels
   If m_HourLabels = True Then
      F = F - 0.2: R = MaxR * F
      If m_ViewClock = 1 Then DrawHourLabels QBColor(15), R, 1, 1
      DrawHourLabels QBColor(0), R, 0, 0
      Else
      F = F - 0.1
      End If
   
   ' sHour "calibration"
   F = F - 0.1: R = MaxR * F
   DrawCircPts 1, QBColor(0), 15, R, 0, 0
   If m_ViewClock = 1 Then DrawCircPts 2, QBColor(15), 30, R, 1, 1
   DrawCircPts 2, QBColor(0), 30, R, 0, 0
   HourHand = F
      
   Picture = Image
   AutoRedraw = False
End Sub

' draw the second-hand
Private Sub DrawSecoHand()
   Dim R As Single
   Dim x As Single
   Dim y As Single

   R = MaxR * MinuHand
   DrawWidth = 1
   x = Xc + R * Cos((270 + sSeco * 6) * Deg)
   y = Yc + R * Sin((270 + sSeco * 6) * Deg)
   Line (Xc, Yc)-(x, y), QBColor(12)
   
End Sub

' draw minute- & hour-hand
Private Sub DrawHands()
   Dim P(4) As POINTAPI
   Dim R As Single, R1 As Single, R2 As Single
   Dim x As Single
   Dim y As Single
   Dim mHour As Single
   
   Cls
   DrawWidth = 1
   FillStyle = 0
   If sHour >= 12 Then mHour = sHour - 12 Else mHour = sHour
   
   Select Case m_ViewHand
      Case Needle
      R = MaxR * HourHand
      DrawWidth = 6
      x = Xc + R * Cos((270 + mHour * 30) * Deg)
      y = Yc + R * Sin((270 + mHour * 30) * Deg)
      Line (Xc, Yc)-(x, y), QBColor(8)
      R = MaxR * MinuHand
      DrawWidth = 3
      x = Xc + R * Cos((270 + sMinu * 6) * Deg)
      y = Yc + R * Sin((270 + sMinu * 6) * Deg)
      Line (Xc, Yc)-(x, y), QBColor(0)
      DrawWidth = 3
      Circle (Xc, Yc), MaxR * 0.05
   
      Case Rhomb
      R1 = MaxR * HourHand: R2 = MaxR * 0.09
      DrawHand QBColor(0), R1, R2, mHour * 30, 0, 0
      R1 = MaxR * MinuHand: R2 = MaxR * 0.05
      DrawHand QBColor(8), R1, R2, sMinu * 6, 0, 0
      Case 2
      R1 = MaxR * HourHand: R2 = MaxR * 0.09
      DrawHand QBColor(15), R1, R2, mHour * 30, 1, 1
      DrawHand QBColor(0), R1, R2, mHour * 30, -1, -1
      DrawHand QBColor(7), R1 * 0.95, R2 * 0.95, mHour * 30, 0, 0
      R1 = MaxR * MinuHand: R2 = MaxR * 0.05
      DrawHand QBColor(15), R1, R2, sMinu * 6, 1, 1
      DrawHand QBColor(0), R1, R2, sMinu * 6, -1, -1
      DrawHand QBColor(7), R1 * 0.95, R2 * 0.95, sMinu * 6, 0, 0
   End Select
   
   If m_SecondHand Then DrawSecoHand
   
   FontSize = 8
   CurrentX = 4
   CurrentY = 0
   ForeColor = 0
   m_ClockTime = Format(Int(sHour), "00") & ":" & Format(Int(sMinu), "00") & ":" & Format(Int(sSeco), "00")
   
   If m_ShowTime Then
      If m_SecondHand Then
         Print m_ClockTime
         Else
         Print Left(ClockTime, 5)
         End If
      End If
End Sub

Private Sub DrawHand(Color As Long, S1 As Single, S2 As Single, waarde As Single, XcOffs As Single, YcOffs As Single)
   Dim P(4) As POINTAPI
   ForeColor = Color
   FillColor = Color
   P(0).x = Xc + XcOffs + S1 * Cos((270 + waarde) * Deg)
   P(0).y = Yc + YcOffs + S1 * Sin((270 + waarde) * Deg)
   P(1).x = Xc + XcOffs + S2 * Cos((waarde) * Deg)
   P(1).y = Yc + YcOffs + S2 * Sin((waarde) * Deg)
   P(2).x = Xc + XcOffs + S2 * Cos((90 + waarde) * Deg) * 2
   P(2).y = Yc + YcOffs + S2 * Sin((90 + waarde) * Deg) * 2
   P(3).x = Xc + XcOffs + S2 * Cos((180 + waarde) * Deg)
   P(3).y = Yc + YcOffs + S2 * Sin((180 + waarde) * Deg)
   Polygon hdc, P(0), 4

End Sub

Private Sub DrawMinuLabels(Color As Long, Radii As Single, XcOffs As Single, YcOffs As Single)
   Dim G As Integer, I As Integer
   Dim x As Single
   Dim y As Single
   
   I = 0
   ForeColor = Color
   For G = 0 To 330 Step 30
      x = Xc + XcOffs + Radii * Cos((270 + G) * Deg)
      y = Yc + YcOffs + Radii * Sin((270 + G) * Deg)
      CurrentX = x - TextWidth(Format(I)) / 2
      CurrentY = y - TextHeight(Format(I)) / 2
      Print Format(I)
      I = I + 5
   Next G

End Sub

Private Sub DrawCircPts(Size As Integer, Color As Long, iStep As Integer, Radii As Single, XcOffs As Single, YcOffs As Single)
   Dim G As Integer
   Dim x As Single
   Dim y As Single

   ForeColor = Color
   DrawWidth = Size
   For G = 0 To 360 - iStep Step iStep
      x = Xc + XcOffs + Radii * Cos(G * Deg)
      y = Yc + YcOffs + Radii * Sin(G * Deg)
      PSet (x, y)
   Next G
End Sub

Private Sub DrawHourLabels(Color As Long, Radii As Single, XcOffs As Single, YcOffs As Single)
   Dim G As Integer, I As Integer
   Dim x As Single
   Dim y As Single
   
   I = 1
   ForeColor = Color
   For G = 30 To 360 Step 30
      x = Xc + XcOffs + Radii * Cos((270 + G) * Deg)
      y = Yc + YcOffs + Radii * Sin((270 + G) * Deg)
      CurrentX = x - TextWidth(Format(I)) / 2
      CurrentY = y - TextHeight(Format(I)) / 2
      Print Format(I)
      I = I + 1
   Next G

End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
   Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
   UserControl.Enabled() = New_Enabled
   PropertyChanged "Enabled"
End Property

Public Property Get ShowTime() As Boolean
Attribute ShowTime.VB_Description = "Show time caption or not."
Attribute ShowTime.VB_ProcData.VB_Invoke_Property = ";Clock"
   ShowTime = m_ShowTime
End Property

Public Property Let ShowTime(ByVal New_ShowTime As Boolean)
   m_ShowTime = New_ShowTime
   PropertyChanged "ShowTime"
   DrawHands
End Property

Public Property Get ClockTime() As String
Attribute ClockTime.VB_Description = "The time the clock is showing (cfr. value)."
Attribute ClockTime.VB_ProcData.VB_Invoke_Property = ";Clock"
Attribute ClockTime.VB_UserMemId = 0
   ClockTime = m_ClockTime
End Property

Public Property Let ClockTime(ByVal New_ClockTime As String)
   m_ClockTime = New_ClockTime
   PropertyChanged "ClockTime"
   NewClockTimeStr
   DrawHands
End Property

Public Property Get SecondHand() As Boolean
Attribute SecondHand.VB_Description = "Show seconds or not."
Attribute SecondHand.VB_ProcData.VB_Invoke_Property = ";Clock"
   SecondHand = m_SecondHand
End Property

Public Property Let SecondHand(ByVal New_SecondHand As Boolean)
   m_SecondHand = New_SecondHand
   PropertyChanged "SecondHand"
   DrawHands
End Property

Public Property Get ViewClock() As ViewClockList
Attribute ViewClock.VB_Description = "Background view style."
Attribute ViewClock.VB_ProcData.VB_Invoke_Property = ";Clock"
   ViewClock = m_ViewClock
End Property

Public Property Let ViewClock(ByVal New_ViewClock As ViewClockList)
   m_ViewClock = New_ViewClock
   PropertyChanged "ViewClock"
   DrawClock
   DrawHands
End Property

Public Property Get ViewHand() As ViewHandList
Attribute ViewHand.VB_Description = "View style of hour-hand and minute-hand."
Attribute ViewHand.VB_ProcData.VB_Invoke_Property = ";Clock"
   ViewHand = m_ViewHand
End Property

Public Property Let ViewHand(ByVal New_ViewHand As ViewHandList)
   m_ViewHand = New_ViewHand
   PropertyChanged "ViewHand"
   DrawHands
End Property

Public Property Get HourLabels() As Boolean
Attribute HourLabels.VB_Description = "Show hour labels or not."
Attribute HourLabels.VB_ProcData.VB_Invoke_Property = ";Clock"
   HourLabels = m_HourLabels
End Property

Public Property Let HourLabels(ByVal New_HourLabels As Boolean)
   m_HourLabels = New_HourLabels
   PropertyChanged "HourLabels"
   DrawClock
   DrawHands
End Property

Public Property Get MinuteLabels() As Boolean
Attribute MinuteLabels.VB_Description = "Show minute labels or not."
Attribute MinuteLabels.VB_ProcData.VB_Invoke_Property = ";Clock"
   MinuteLabels = m_MinuteLabels
End Property

Public Property Let MinuteLabels(ByVal New_MinuteLabels As Boolean)
   m_MinuteLabels = New_MinuteLabels
   PropertyChanged "MinuteLabels"
   DrawClock
   DrawHands
End Property

Private Sub UserControl_Initialize()
   PI = 4 * Atn(1)
   Deg = PI / 180
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
   m_ShowTime = m_def_ShowTime
   m_ClockTime = m_def_ClockTime
   m_SecondHand = m_def_SecondHand
   m_ViewClock = m_def_ViewClock
   m_ViewHand = m_def_ViewHand
   m_HourLabels = m_def_HourLabels
   m_MinuteLabels = m_def_MinuteLabels
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   NewClockTimeXY x, y
   DrawHands
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
   If Button = 0 Then Exit Sub
   NewClockTimeXY x, y
   DrawHands
End Sub

Private Sub UserControl_Paint()
   DrawHands
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
   m_ShowTime = PropBag.ReadProperty("ShowTime", m_def_ShowTime)
   m_ClockTime = PropBag.ReadProperty("ClockTime", m_def_ClockTime)
   m_SecondHand = PropBag.ReadProperty("SecondHand", m_def_SecondHand)
   m_ViewClock = PropBag.ReadProperty("ViewClock", m_def_ViewClock)
   m_ViewHand = PropBag.ReadProperty("ViewHand", m_def_ViewHand)
   m_HourLabels = PropBag.ReadProperty("HourLabels", m_def_HourLabels)
   m_MinuteLabels = PropBag.ReadProperty("MinuteLabels", m_def_MinuteLabels)
End Sub

Private Sub UserControl_Resize()
   Width = Height
   MaxR = ScaleWidth / 2
   Xc = MaxR: Yc = MaxR
   DrawClock
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

   Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
   Call PropBag.WriteProperty("ShowTime", m_ShowTime, m_def_ShowTime)
   Call PropBag.WriteProperty("ClockTime", m_ClockTime, m_def_ClockTime)
   Call PropBag.WriteProperty("SecondHand", m_SecondHand, m_def_SecondHand)
   Call PropBag.WriteProperty("ViewClock", m_ViewClock, m_def_ViewClock)
   Call PropBag.WriteProperty("ViewHand", m_ViewHand, m_def_ViewHand)
   Call PropBag.WriteProperty("HourLabels", m_HourLabels, m_def_HourLabels)
   Call PropBag.WriteProperty("MinuteLabels", m_MinuteLabels, m_def_MinuteLabels)
End Sub

